## intel-ipsec-mb 0.48

=== Makefile ===
#
# Copyright (c) 2012-2017, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
LIB = libIPSec_MB
VERSION = 0.48
SO_VERSION = 0
SHARED ?= n

USE_YASM ?= n
YASM ?= yasm
NASM ?= nasm

OBJ_DIR = obj

INCLUDE_DIRS := include .
INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)

CC ?= gcc

CFLAGS := -DLINUX $(EXTRA_CFLAGS) $(INCLUDES) \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition

ifeq ($(DEBUG),y)
CFLAGS += -g -O0 -DDEBUG
LDFLAGS += -g
else
CFLAGS += -O3 -fstack-protector -D_FORTIFY_SOURCE=2
endif

# so or static build
ifeq ($(SHARED),y)
CFLAGS += -fPIC
LIBNAME = $(LIB).so.$(VERSION)
LIBPERM = 0755
LDFLAGS += -z noexecstack -z relro -z now
else
CFLAGS += -fPIE
LIBNAME = $(LIB).a
LIBPERM = 0644
LDFLAGS += -g
endif

ASM_INCLUDE_DIRS := include . avx avx2 avx512 sse

YASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I $i)
YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__ $(YASM_INCLUDES)

NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
NASM_FLAGS := -felf64 -Xgnu -gdwarf -DLINUX -D__linux__ $(NASM_INCLUDES)

lib_objs := \
	aes128_cbc_dec_by4_sse.o \
	aes128_cbc_dec_by8_avx.o \
	aes128_cntr_by4_sse.o \
	aes128_cntr_by8_avx.o \
	aes128_ecbenc_x3.o \
	aes192_cbc_dec_by4_sse.o \
	aes192_cbc_dec_by8_avx.o \
	aes192_cntr_by4_sse.o \
	aes192_cntr_by8_avx.o \
	aes256_cbc_dec_by4_sse.o \
	aes256_cbc_dec_by8_avx.o \
	aes256_cntr_by4_sse.o \
	aes256_cntr_by8_avx.o \
	aes_cfb_128_sse.o \
	aes_cfb_128_avx.o \
	aes128_cbc_mac_x4.o \
	aes128_cbc_mac_x8.o \
	aes_cbc_enc_128_x4.o \
	aes_cbc_enc_128_x8.o \
	aes_cbc_enc_192_x4.o \
	aes_cbc_enc_192_x8.o \
	aes_cbc_enc_256_x4.o \
	aes_cbc_enc_256_x8.o \
	aes_keyexp_128.o \
	aes_keyexp_192.o \
	aes_keyexp_256.o \
	aes_xcbc_mac_128_x4.o \
	aes_xcbc_mac_128_x8.o \
	mb_mgr_aes192_flush_avx.o \
	mb_mgr_aes192_flush_sse.o \
	mb_mgr_aes192_submit_avx.o \
	mb_mgr_aes192_submit_sse.o \
	mb_mgr_aes256_flush_avx.o \
	mb_mgr_aes256_flush_sse.o \
	mb_mgr_aes256_submit_avx.o \
	mb_mgr_aes256_submit_sse.o \
	mb_mgr_aes_flush_avx.o \
	mb_mgr_aes_flush_sse.o \
	mb_mgr_aes_submit_avx.o \
	mb_mgr_aes_submit_sse.o \
	mb_mgr_aes_xcbc_flush_avx.o \
	mb_mgr_aes_xcbc_flush_sse.o \
	mb_mgr_aes_xcbc_submit_avx.o \
	mb_mgr_aes_xcbc_submit_sse.o \
	mb_mgr_hmac_flush_avx.o \
	mb_mgr_hmac_flush_avx2.o \
	mb_mgr_hmac_flush_sse.o \
	mb_mgr_hmac_flush_ni_sse.o \
	mb_mgr_hmac_flush_avx512.o \
	mb_mgr_hmac_md5_flush_avx.o \
	mb_mgr_hmac_md5_flush_avx2.o \
	mb_mgr_hmac_md5_flush_sse.o \
	mb_mgr_hmac_md5_submit_avx.o \
	mb_mgr_hmac_md5_submit_avx2.o \
	mb_mgr_hmac_md5_submit_sse.o \
	mb_mgr_hmac_sha_224_flush_avx.o \
	mb_mgr_hmac_sha_224_flush_avx2.o \
	mb_mgr_hmac_sha_224_flush_avx512.o \
	mb_mgr_hmac_sha_224_flush_sse.o \
	mb_mgr_hmac_sha_224_flush_ni_sse.o \
	mb_mgr_hmac_sha_224_submit_avx.o \
	mb_mgr_hmac_sha_224_submit_avx2.o \
	mb_mgr_hmac_sha_224_submit_avx512.o \
	mb_mgr_hmac_sha_224_submit_sse.o \
	mb_mgr_hmac_sha_224_submit_ni_sse.o \
	mb_mgr_hmac_sha_256_flush_avx.o \
	mb_mgr_hmac_sha_256_flush_avx2.o \
	mb_mgr_hmac_sha_256_flush_sse.o \
	mb_mgr_hmac_sha_256_flush_ni_sse.o \
	mb_mgr_hmac_sha_256_flush_avx512.o \
	mb_mgr_hmac_sha_256_submit_avx.o \
	mb_mgr_hmac_sha_256_submit_avx2.o \
	mb_mgr_hmac_sha_256_submit_sse.o \
	mb_mgr_hmac_sha_256_submit_ni_sse.o \
	mb_mgr_hmac_sha_256_submit_avx512.o \
	mb_mgr_hmac_sha_384_flush_avx.o \
	mb_mgr_hmac_sha_384_flush_avx2.o \
	mb_mgr_hmac_sha_384_flush_avx512.o \
	mb_mgr_hmac_sha_384_flush_sse.o \
	mb_mgr_hmac_sha_384_submit_avx.o \
	mb_mgr_hmac_sha_384_submit_avx2.o \
	mb_mgr_hmac_sha_384_submit_avx512.o \
	mb_mgr_hmac_sha_384_submit_sse.o \
	mb_mgr_hmac_sha_512_flush_avx.o \
	mb_mgr_hmac_sha_512_flush_avx2.o \
	mb_mgr_hmac_sha_512_flush_avx512.o \
	mb_mgr_hmac_sha_512_flush_sse.o \
	mb_mgr_hmac_sha_512_submit_avx.o \
	mb_mgr_hmac_sha_512_submit_avx2.o \
	mb_mgr_hmac_sha_512_submit_avx512.o \
	mb_mgr_hmac_sha_512_submit_sse.o \
	mb_mgr_hmac_submit_avx.o \
	mb_mgr_hmac_submit_avx2.o \
	mb_mgr_hmac_submit_sse.o \
	mb_mgr_hmac_submit_ni_sse.o \
	mb_mgr_hmac_submit_avx512.o \
	mb_mgr_des_avx512.o \
	md5_x4x2_avx.o \
	md5_x4x2_sse.o \
	md5_x8x2_avx2.o \
	save_xmms.o \
	sha1_mult_avx.o \
	sha1_mult_sse.o \
	sha1_ni_x2_sse.o \
	sha1_one_block_avx.o \
	sha1_one_block_sse.o \
	sha1_x8_avx2.o \
	sha1_x16_avx512.o \
	sha224_one_block_avx.o \
	sha224_one_block_sse.o \
	sha256_oct_avx2.o \
	sha256_one_block_avx.o \
	sha256_one_block_sse.o \
	sha256_ni_x2_sse.o \
	sha256_x16_avx512.o \
	sha384_one_block_avx.o \
	sha384_one_block_sse.o \
	sha512_one_block_avx.o \
	sha512_one_block_sse.o \
	sha512_x2_avx.o \
	sha512_x2_sse.o \
	sha512_x4_avx2.o \
	sha512_x8_avx512.o \
	sha_256_mult_avx.o \
	sha_256_mult_sse.o \
	\
	aes_xcbc_expand_key.o \
	mb_mgr_avx.o \
	mb_mgr_avx2.o \
	mb_mgr_avx512.o \
	mb_mgr_sse.o \
	md5_one_block.o \
	des_key.o \
	des_basic.o \
	des_x16_avx512.o

gcm_objs := gcm128_sse.o gcm192_sse.o gcm256_sse.o \
	gcm128_avx_gen2.o gcm192_avx_gen2.o gcm256_avx_gen2.o \
	gcm128_avx_gen4.o gcm192_avx_gen4.o gcm256_avx_gen4.o

ifeq ($(NO_GCM), y)
obj2_files := $(lib_objs:%=$(OBJ_DIR)/%)
CFLAGS += -DNO_GCM
else
obj2_files := $(lib_objs:%=$(OBJ_DIR)/%) $(gcm_objs:%=$(OBJ_DIR)/%)
endif

all: $(LIBNAME)

$(LIBNAME): $(obj2_files)
ifeq ($(SHARED),y)
	$(CC) -shared -Wl,-soname,$(LIB).so.$(SO_VERSION) -o $(LIBNAME) $^ -lc
	ln -f -s $(LIBNAME) $(LIB).so.$(SO_VERSION)
	ln -f -s $(LIB).so.$(SO_VERSION) $(LIB).so
else
	ar -qcs $@ $^
endif

$(obj2_files): | $(OBJ_DIR)

$(OBJ_DIR)/%.o:%.c
	@ echo "Making object file $@ "
	$(CC) -c $(CFLAGS) $< -o $@
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:%.asm
	@ echo "Making object file $@ "
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -o $@ $(NASM_FLAGS) $<
endif
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:sse/%.c
	@ echo "Making object file $@ "
	$(CC) -c $(CFLAGS) $< -o $@
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:sse/%.asm
	@ echo "Making object file $@ "
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -o $@ $(NASM_FLAGS) $<
endif
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:avx/%.c
	@ echo "Making object file $@ "
	$(CC) -c $(CFLAGS) $< -o $@
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:avx/%.asm
	@ echo "Making object file $@ "
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -o $@ $(NASM_FLAGS) $<
endif
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:avx2/%.c
	@ echo "Making object file $@ "
	$(CC) -c $(CFLAGS) $< -o $@
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:avx2/%.asm
	@ echo "Making object file $@ "
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -o $@ $(NASM_FLAGS) $<
endif
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:avx512/%.c
	@ echo "Making object file $@ "
	$(CC) -c $(CFLAGS) $< -o $@
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:avx512/%.asm
	@ echo "Making object file $@ "
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -o $@ $(NASM_FLAGS) $<
endif
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR)/%.o:include/%.asm
	@ echo "Making object file $@ "
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -o $@ $(NASM_FLAGS) $<
endif
	@ echo "--------------------------------------------------------------"

$(OBJ_DIR):
	mkdir $(OBJ_DIR)

.PHONY: TAGS
TAGS:
	find ./ -name '*.[ch]' | etags -
	find ./ -name '*.asm'  | etags -a -
	find ./ -name '*.inc'  | etags -a -

.PHONY: clean
clean:
	rm -Rf $(obj2_files)
	rm -f $(LIB).a $(LIB).so*

SOURCES_DIRS := . sse avx avx2 avx512 include
SOURCES := $(foreach dir,$(SOURCES_DIRS),$(wildcard $(dir)/*.[ch]) $(wildcard $(dir)/*.asm) $(wildcard $(dir)/*.inc))
SOURCES_STYLE := $(foreach infile,$(SOURCES),-f $(infile))
CHECKPATCH?=checkpatch.pl
# SPACING - produces false positives with tyepdefs and *
# CONSTANT_COMPARISON - forbids defensive programming technique
# USE_FUNC - produces false positives for Windows target
# INITIALISED_STATIC, LEADING_SPACE, SPLIT_STRING, CODE_INDENT,
# PREFER_ALIGNED, UNSPECIFIED_INT, ARRAY_SIZE, GLOBAL_INITIALISERS,
# NEW_TYPEDEFS, AVOID_EXTERNS, COMPLEX_MACRO, BLOCK_COMMENT_STYLE
# - found obsolete in this project
.PHONY: style
style:
	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
--ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
NEW_TYPEDEFS,AVOID_EXTERNS,COMPLEX_MACRO,PREFER_ALIGNED,USE_FUNC,\
CONSTANT_COMPARISON,SPACING $(SOURCES_STYLE)

=== LibPerfApp/Makefile ===
# Copyright (c) 2017, Intel Corporation
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

EXE=ipsec_perf
LIBDIR ?= ../
LDFLAGS = -L$(LIBDIR) -fPIE -z noexecstack -z relro -z now -pthread
LDLIBS = -lIPSec_MB

INCLUDE_DIRS := $(LIBDIR) $(LIBDIR)/include
INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I$i)

CFLAGS := -DLINUX $(INCLUDES) \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-pthread

ifeq ($(DEBUG),y)
CFLAGS += -g -DDEBUG -O0
LDFLAGS += -g
else
CFLAGS += -O3 -fPIE -fstack-protector -D_FORTIFY_SOURCE=2
endif

SOURCES := ipsec_perf.c
OBJECTS := $(SOURCES:%.c=%.o)

CHECKPATCH ?= checkpatch.pl
CPPCHECK ?= cppcheck

.PHONY: all clean style cppcheck

all: $(EXE)

$(EXE): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

ipsec_perf.o: ipsec_perf.c

.PHONY: clean
clean:
	-rm -f $(OBJECTS)
	-rm -f $(EXE)

SOURCES_STYLE := $(foreach infile,$(SOURCES),-f $(infile))
CHECKPATCH?=checkpatch.pl
.PHONY: style
style:
	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
--ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
COMPLEX_MACRO,SPACING,STORAGE_CLASS $(SOURCES_STYLE)

=== LibTestApp/Makefile ===
#
# Copyright (c) 2012-2017, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

APP := ipsec_MB_testapp

LIBDIR ?= ../
LDFLAGS = -L$(LIBDIR) -fPIE -z noexecstack -z relro -z now
LDLIBS = -lIPSec_MB
CFLAGS = -g -DLINUX -I../include -I..

ifeq ($(DEBUG),y)
CFLAGS += -O0 -DDEBUG
LDFLAGS += -g
else
CFLAGS += -O3
endif

SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c
OBJECTS := $(SOURCES:%.c=%.o)

all: $(APP)

$(APP): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

main.o: main.c do_test.h
gcm_test.o: gcm_test.c gcm_ctr_vectors_test.h
ctr_test.o: ctr_test.c gcm_ctr_vectors_test.h
des_test.o: des_test.c
ccm_test.o: ccm_test.c
customop_test.o: customop_test.c customop_test.h

.PHONY: clean
clean:
	-rm -f $(OBJECTS) $(APP)

SOURCES_STYLE := $(foreach infile,$(SOURCES),-f $(infile))
CHECKPATCH?=checkpatch.pl
.PHONY: style
style:
	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color --max-line-length=100 \
--ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
AVOID_EXTERNS,USE_FUNC,CONSTANT_COMPARISON $(SOURCES_STYLE)

=== debian/changelog ===
intel-ipsec-mb (0.48-4) unstable; urgency=medium

  * Add manpage and update README (LP: #1756175)
    - upstream commits a544139781f6cb12 and 4a8557cec413933b

 -- Colin Ian King <colin.king@canonical.com>  Thu, 15 Mar 2018 18:59:42 +0000

intel-ipsec-mb (0.48-3) unstable; urgency=medium

  * disable stack execution flag in shared library file (LP: #1754996)
    - upstream commit 94f3ebb21e09e992 ("Fix for issue #18 to disable
      stack execution flag in ELF shared library file")

 -- Colin Ian King <colin.king@canonical.com>  Sun, 11 Mar 2018 15:38:11 +0000

intel-ipsec-mb (0.48-2) unstable; urgency=medium

  * Add in some latest upstream updates:
    - AES-CMAC-128 and AES-CMAC-96 authentication support
    - Year update in copyrights
    - Added option to ipsec_perf to affinitize threads to cores
    - Library gets compiled to SO/DLL by default
    - Re-enable static library build to override default SO library build
      so both are now built

 -- Colin Ian King <colin.king@canonical.com>  Thu, 1 Mar 2018 13:42:57 +0000

intel-ipsec-mb (0.48-1) unstable; urgency=medium

  * Initial debian version (Closes: #890519)
  * Add in extra functionality and fixes since 0.48-1 release:
    - DES cipher added to LibPerfApp. Library version bump.
    - AVX512 DES improvement to smooth out performance 'stairs'
    - Fix for issue #16 (seg fault using HMAC-SHA512 or
      HMAC-SHA384 on AVX2)
    - 3DES support
    - AVX512 version of 3DES

 -- Colin Ian King <colin.king@canonical.com>  Thu, 15 Feb 2018 10:34:15 +0000

=== debian/control ===
Source: intel-ipsec-mb
Section: utils
Priority: optional
Maintainer: Colin Ian King <colin.king@canonical.com>
Uploaders: Kamal Mostafa <kamal@whence.com>
Build-Depends: debhelper (>= 11), nasm
Standards-Version: 4.1.2
Homepage: https://github.com/intel/intel-ipsec-mb

Package: libipsec-mb
Section: libs
Architecture: amd64
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

Package: libipsec-mb-dev
Section: libdevel
Architecture: linux-amd64
Priority: optional
Depends: ${misc:Depends}, libipsec-mb
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

=== debian/rules ===
#!/usr/bin/make -f

DESTDIR=$$(pwd)/debian/tmp
LIBDIR=/usr/lib/intel-ipsec-mb
HDRDIR=/usr/include/intel-ipsec-mb
MANDIR=/usr/share/man/man7

VERSION_MAJOR=$(shell grep "^VERSION = " Makefile | tr '.' ' ' | cut -d' ' -f3)
VERSION_MINOR=$(shell grep "^VERSION = " Makefile | tr '.' ' ' | cut -d' ' -f4)

MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7

#
# DOCDIR is the same path as the library copyright file
#
DOCDIR=/usr/share/doc/libipsec-mb

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); SHARED=y dh_auto_build
	rm obj/*.o
	$(shell dpkg-buildflags --export=sh); SHARED=n dh_auto_build

override_dh_auto_install:
	# Documentation
	install -d ${DESTDIR}${DOCDIR}
	install -m 0644 $$(pwd)/LICENSE ${DESTDIR}${DOCDIR}

	# Install the library
	install -d ${DESTDIR}${LIBDIR}
	install -m 0644 -s $$(pwd)/libIPSec_MB.a ${DESTDIR}${LIBDIR}
	install -m 0644 -s $$(pwd)/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so

	#dpkg-shlibdeps ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}

	# Install the header files
	install -d ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/include/types.h ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/constants.h ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/job_aes_hmac.h ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/asm_types.h ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/mb_mgr.h ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/gcm_defines.h ${DESTDIR}${HDRDIR}

	# Install man pages
	install -d ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/${MAN1} ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/${MAN2} ${DESTDIR}${MANDIR}

%:
	dh $@
	dh_makeshlibs
	dh_shlibdeps

## intel-ipsec-mb 0.50

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2017, Intel Corporation
+# Copyright (c) 2012-2018, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -12,7 +12,7 @@
 #     * Neither the name of Intel Corporation nor the names of its contributors
 #       may be used to endorse or promote products derived from this software
 #       without specific prior written permission.
-# 
+#
 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 # AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
@@ -24,10 +24,27 @@
 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 #
+
 LIB = libIPSec_MB
-VERSION = 0.48
-SO_VERSION = 0
-SHARED ?= n
+SHARED ?= y
+IMB_HDR = intel-ipsec-mb.h
+
+# Detect library version
+IMB_VERSION = $(shell grep -e "IMB_VERSION_STR" $(IMB_HDR) | cut -d'"' -f2)
+ifeq ($(IMB_VERSION),)
+$(error "Failed to detect library version!")
+endif
+
+VERSION = $(shell echo $(IMB_VERSION) | cut -d. -f1-2)
+SO_VERSION = $(shell echo $(VERSION) | cut -d. -f1)
+
+PREFIX ?= /usr
+LIB_INSTALL_DIR ?= $(PREFIX)/lib
+HDR_DIR ?= $(PREFIX)/include
+MAN_DIR ?= $(PREFIX)/man/man7
+MAN1 = libipsec-mb.7
+MAN2 = libipsec-mb-dev.7
+NOLDCONFIG ?= n
 
 USE_YASM ?= n
 YASM ?= yasm
@@ -104,6 +121,7 @@
 	aes_keyexp_256.o \
 	aes_xcbc_mac_128_x4.o \
 	aes_xcbc_mac_128_x8.o \
+	aes_cmac_subkey_gen.o \
 	mb_mgr_aes192_flush_avx.o \
 	mb_mgr_aes192_flush_sse.o \
 	mb_mgr_aes192_submit_avx.o \
@@ -203,14 +221,18 @@
 	sha_256_mult_sse.o \
 	\
 	aes_xcbc_expand_key.o \
+	alloc.o \
 	mb_mgr_avx.o \
 	mb_mgr_avx2.o \
 	mb_mgr_avx512.o \
 	mb_mgr_sse.o \
 	md5_one_block.o \
+	sha_one_block.o \
 	des_key.o \
 	des_basic.o \
-	des_x16_avx512.o
+	des_x16_avx512.o \
+	const.o \
+	version.o
 
 gcm_objs := gcm128_sse.o gcm192_sse.o gcm256_sse.o \
 	gcm128_avx_gen2.o gcm192_avx_gen2.o gcm256_avx_gen2.o \
@@ -231,15 +253,44 @@
 	ln -f -s $(LIBNAME) $(LIB).so.$(SO_VERSION)
 	ln -f -s $(LIB).so.$(SO_VERSION) $(LIB).so
 else
-	ar -qcs $@ $^
-endif
+	$(AR) -qcs $@ $^
+endif
+
+.PHONY: install
+install: $(LIBNAME)
+	install -d $(HDR_DIR)
+	install -m 0644 $(IMB_HDR) $(HDR_DIR)
+	install -d $(LIB_INSTALL_DIR)
+	install -s -m $(LIBPERM) $(LIBNAME) $(LIB_INSTALL_DIR)
+	install -d $(MAN_DIR)
+	install -m 0444 $(MAN1) $(MAN_DIR)
+	install -m 0444 $(MAN2) $(MAN_DIR)
+ifeq ($(SHARED),y)
+	cd $(LIB_INSTALL_DIR); \
+		ln -f -s $(LIB).so.$(VERSION) $(LIB).so.$(SO_VERSION); \
+		ln -f -s $(LIB).so.$(SO_VERSION) $(LIB).so
+ifneq ($(NOLDCONFIG),y)
+	ldconfig
+endif
+endif
+
+.PHONY: uninstall
+uninstall: $(LIBNAME)
+	-rm -f $(HDR_DIR)/$(IMB_HDR)
+	-rm -f $(LIB_INSTALL_DIR)/$(LIBNAME)
+	-rm -f $(MAN_DIR)/$(MAN1)
+	-rm -f $(MAN_DIR)/$(MAN2)
+ifeq ($(SHARED),y)
+	-rm -f $(LIB_INSTALL_DIR)/$(LIB).so.$(SO_VERSION)
+	-rm -f $(LIB_INSTALL_DIR)/$(LIB).so
+endif
+
 
 $(obj2_files): | $(OBJ_DIR)
 
 $(OBJ_DIR)/%.o:%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:%.asm
 	@ echo "Making object file $@ "
@@ -248,12 +299,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:sse/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:sse/%.asm
 	@ echo "Making object file $@ "
@@ -262,12 +311,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx/%.asm
 	@ echo "Making object file $@ "
@@ -276,12 +323,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx2/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx2/%.asm
 	@ echo "Making object file $@ "
@@ -290,12 +335,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx512/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx512/%.asm
 	@ echo "Making object file $@ "
@@ -304,7 +347,6 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:include/%.asm
 	@ echo "Making object file $@ "
@@ -313,7 +355,6 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR):
 	mkdir $(OBJ_DIR)
@@ -347,4 +388,3 @@
 UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
 NEW_TYPEDEFS,AVOID_EXTERNS,COMPLEX_MACRO,PREFER_ALIGNED,USE_FUNC,\
 CONSTANT_COMPARISON,SPACING $(SOURCES_STYLE)
-

=== LibTestApp/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2017, Intel Corporation
+# Copyright (c) 2012-2018, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -26,11 +26,26 @@
 #
 
 APP := ipsec_MB_testapp
+INSTPATH ?= /usr/include/intel-ipsec-mb.h
 
-LIBDIR ?= ../
-LDFLAGS = -L$(LIBDIR) -fPIE -z noexecstack -z relro -z now
+CFLAGS = -g -DLINUX -D_GNU_SOURCE \
+	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
+	-Wcast-qual -Wundef -Wwrite-strings  \
+	-Wformat -Wformat-security \
+	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
+	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition
+
+LDFLAGS = -fPIE -z noexecstack -z relro -z now
 LDLIBS = -lIPSec_MB
-CFLAGS = -g -DLINUX -I../include -I..
+
+ifeq ("$(shell test -r $(INSTPATH) && echo -n yes)","yes")
+# library installed
+CFLAGS +=
+else
+# library not installed
+CFLAGS +=  -I../include -I../
+LDFLAGS += -L../
+endif
 
 ifeq ($(DEBUG),y)
 CFLAGS += -O0 -DDEBUG
@@ -39,7 +54,9 @@
 CFLAGS += -O3
 endif
 
-SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c
+SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c \
+	cmac_test.c utils.c hmac_sha1_test.c hmac_sha256_sha512_test.c \
+	hmac_md5_test.c
 OBJECTS := $(SOURCES:%.c=%.o)
 
 all: $(APP)
@@ -51,8 +68,13 @@
 gcm_test.o: gcm_test.c gcm_ctr_vectors_test.h
 ctr_test.o: ctr_test.c gcm_ctr_vectors_test.h
 des_test.o: des_test.c
-ccm_test.o: ccm_test.c
+ccm_test.o: ccm_test.c utils.h
+cmac_test.o: cmac_test.c utils.h
+hmac_sha1_test.o: hmac_sha1_test.c utils.h
+hmac_md5_test.o: hmac_md5_test.c utils.h
+hmac_sha256_sha512_test.o: hmac_sha256_sha512_test.c utils.h
 customop_test.o: customop_test.c customop_test.h
+utils.o: utils.c utils.h
 
 .PHONY: clean
 clean:
@@ -62,7 +84,7 @@
 CHECKPATCH?=checkpatch.pl
 .PHONY: style
 style:
-	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color --max-line-length=100 \
+	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
 --ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
 UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
 AVOID_EXTERNS,USE_FUNC,CONSTANT_COMPARISON $(SOURCES_STYLE)

=== debian/changelog ===
intel-ipsec-mb (0.50-2) unstable; urgency=medium

  [ Dmitry Eremin-Solenikov ]
  * Install libraries and headers into system path (Closes: #896788)
    Note: The package name has been renamed from libipsec-mb to libipsec-mb0
  * Rename library package to follow soname
  * Use dh_installdocs to install LICENSE file.
  * Install README file.

 -- Colin Ian King <colin.king@canonical.com>  Fri, 13 Jul 2018 13:52:59 +0100

intel-ipsec-mb (0.50-1) unstable; urgency=medium

  * Sync to latest 0.50 release
  * Add fix to disable stack execution flag in const.asm

 -- Colin Ian King <colin.king@canonical.com>  Tue, 3 Jul 2018 10:40:53 +0100

intel-ipsec-mb (0.49-1) unstable; urgency=medium

  * Sync to latest 0.49 release, drop debian/patches that are
    no longer required

 -- Colin Ian King <colin.king@canonical.com>  Tue, 3 Apr 2018 14:24:59 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DESTDIR=$$(pwd)/debian/tmp
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
HDRDIR=/usr/include
MANDIR=/usr/share/man/man7

VERSION_MAJOR=$(shell grep -e "IMB_VERSION_STR" intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f1)
VERSION_MINOR=$(shell grep -e "IMB_VERSION_STR" intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f2)
VERSION_PATCH=$(shell grep -e "IMB_VERSION_STR" intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f3)

MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); SHARED=y dh_auto_build
	rm obj/*.o
	$(shell dpkg-buildflags --export=sh); SHARED=n dh_auto_build

override_dh_auto_install:
	# Install the library
	install -d ${DESTDIR}${LIBDIR}
	install -m 0644 -s $$(pwd)/libIPSec_MB.a ${DESTDIR}${LIBDIR}
	install -m 0644 -s $$(pwd)/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so

	#dpkg-shlibdeps ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}

	# Install the header files
	install -d ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/intel-ipsec-mb.h ${DESTDIR}${HDRDIR}

	# Install man pages
	install -d ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/${MAN1} ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/${MAN2} ${DESTDIR}${MANDIR}

%:
	dh $@
	dh_makeshlibs
	dh_shlibdeps

## intel-ipsec-mb 0.52

=== Makefile ===
--- 
+++ 
@@ -52,7 +52,7 @@
 
 OBJ_DIR = obj
 
-INCLUDE_DIRS := include .
+INCLUDE_DIRS := include . no-aesni
 INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)
 
 CC ?= gcc
@@ -65,10 +65,28 @@
 	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition
 
 ifeq ($(DEBUG),y)
-CFLAGS += -g -O0 -DDEBUG
+CFLAGS += -g -DDEBUG
+OPT = -O0
 LDFLAGS += -g
 else
-CFLAGS += -O3 -fstack-protector -D_FORTIFY_SOURCE=2
+OPT = -O3
+CFLAGS += -fstack-protector -D_FORTIFY_SOURCE=2
+endif
+
+# prevent SIMD optimizations for non-aesni modules
+CFLAGS_NO_SIMD = $(CFLAGS) -O1
+CFLAGS += $(OPT)
+
+# Set architectural optimizations for GCC/CC
+ifeq ($(CC),$(filter $(CC),gcc cc))
+GCC_VERSION = $(shell $(CC) -dumpversion | cut -d. -f1)
+GCC_GE_V5 = $(shell [ $(GCC_VERSION) -ge 5 ] && echo true)
+ifeq ($(GCC_GE_V5),true)
+OPT_SSE = -march=nehalem
+OPT_AVX = -march=sandybridge
+OPT_AVX2 = -march=haswell
+OPT_AVX512 = -march=broadwell
+endif
 endif
 
 # so or static build
@@ -94,50 +112,73 @@
 
 lib_objs := \
 	aes128_cbc_dec_by4_sse.o \
+	aes128_cbc_dec_by4_sse_no_aesni.o \
 	aes128_cbc_dec_by8_avx.o \
 	aes128_cntr_by4_sse.o \
+	aes128_cntr_by4_sse_no_aesni.o \
 	aes128_cntr_by8_avx.o \
 	aes128_ecbenc_x3.o \
 	aes192_cbc_dec_by4_sse.o \
+	aes192_cbc_dec_by4_sse_no_aesni.o \
 	aes192_cbc_dec_by8_avx.o \
 	aes192_cntr_by4_sse.o \
+	aes192_cntr_by4_sse_no_aesni.o \
 	aes192_cntr_by8_avx.o \
 	aes256_cbc_dec_by4_sse.o \
+	aes256_cbc_dec_by4_sse_no_aesni.o \
 	aes256_cbc_dec_by8_avx.o \
 	aes256_cntr_by4_sse.o \
+	aes256_cntr_by4_sse_no_aesni.o \
 	aes256_cntr_by8_avx.o \
 	aes_cfb_128_sse.o \
+	aes_cfb_128_sse_no_aesni.o \
 	aes_cfb_128_avx.o \
 	aes128_cbc_mac_x4.o \
+	aes128_cbc_mac_x4_no_aesni.o \
 	aes128_cbc_mac_x8.o \
 	aes_cbc_enc_128_x4.o \
+	aes_cbc_enc_128_x4_no_aesni.o \
 	aes_cbc_enc_128_x8.o \
 	aes_cbc_enc_192_x4.o \
+	aes_cbc_enc_192_x4_no_aesni.o \
 	aes_cbc_enc_192_x8.o \
 	aes_cbc_enc_256_x4.o \
+	aes_cbc_enc_256_x4_no_aesni.o \
 	aes_cbc_enc_256_x8.o \
 	aes_keyexp_128.o \
 	aes_keyexp_192.o \
 	aes_keyexp_256.o \
 	aes_xcbc_mac_128_x4.o \
+	aes_xcbc_mac_128_x4_no_aesni.o \
 	aes_xcbc_mac_128_x8.o \
 	aes_cmac_subkey_gen.o \
 	mb_mgr_aes192_flush_avx.o \
 	mb_mgr_aes192_flush_sse.o \
+	mb_mgr_aes192_flush_sse_no_aesni.o \
 	mb_mgr_aes192_submit_avx.o \
 	mb_mgr_aes192_submit_sse.o \
+	mb_mgr_aes192_submit_sse_no_aesni.o \
 	mb_mgr_aes256_flush_avx.o \
 	mb_mgr_aes256_flush_sse.o \
+	mb_mgr_aes256_flush_sse_no_aesni.o \
 	mb_mgr_aes256_submit_avx.o \
 	mb_mgr_aes256_submit_sse.o \
+	mb_mgr_aes256_submit_sse_no_aesni.o \
 	mb_mgr_aes_flush_avx.o \
 	mb_mgr_aes_flush_sse.o \
+	mb_mgr_aes_flush_sse_no_aesni.o \
 	mb_mgr_aes_submit_avx.o \
 	mb_mgr_aes_submit_sse.o \
+	mb_mgr_aes_submit_sse_no_aesni.o \
+	mb_mgr_aes_cmac_submit_flush_sse.o \
+	mb_mgr_aes_cmac_submit_flush_sse_no_aesni.o \
+	mb_mgr_aes_cmac_submit_flush_avx.o\
 	mb_mgr_aes_xcbc_flush_avx.o \
 	mb_mgr_aes_xcbc_flush_sse.o \
+	mb_mgr_aes_xcbc_flush_sse_no_aesni.o \
 	mb_mgr_aes_xcbc_submit_avx.o \
 	mb_mgr_aes_xcbc_submit_sse.o \
+	mb_mgr_aes_xcbc_submit_sse_no_aesni.o \
 	mb_mgr_hmac_flush_avx.o \
 	mb_mgr_hmac_flush_avx2.o \
 	mb_mgr_hmac_flush_sse.o \
@@ -219,24 +260,29 @@
 	sha512_x8_avx512.o \
 	sha_256_mult_avx.o \
 	sha_256_mult_sse.o \
-	\
 	aes_xcbc_expand_key.o \
 	alloc.o \
 	mb_mgr_avx.o \
 	mb_mgr_avx2.o \
 	mb_mgr_avx512.o \
 	mb_mgr_sse.o \
+	mb_mgr_sse_no_aesni.o \
 	md5_one_block.o \
 	sha_one_block.o \
 	des_key.o \
 	des_basic.o \
 	des_x16_avx512.o \
 	const.o \
-	version.o
-
-gcm_objs := gcm128_sse.o gcm192_sse.o gcm256_sse.o \
+	version.o \
+	cpu_feature.o \
+	aesni_emu.o
+
+gcm_objs := gcm.o gcm128_sse.o gcm192_sse.o gcm256_sse.o \
 	gcm128_avx_gen2.o gcm192_avx_gen2.o gcm256_avx_gen2.o \
-	gcm128_avx_gen4.o gcm192_avx_gen4.o gcm256_avx_gen4.o
+	gcm128_avx_gen4.o gcm192_avx_gen4.o gcm256_avx_gen4.o \
+	gcm128_sse_no_aesni.o gcm192_sse_no_aesni.o gcm256_sse_no_aesni.o \
+	gcm128_vaes_avx512.o gcm192_vaes_avx512.o gcm256_vaes_avx512.o \
+	gcm128_avx512.o gcm192_avx512.o gcm256_avx512.o
 
 ifeq ($(NO_GCM), y)
 obj2_files := $(lib_objs:%=$(OBJ_DIR)/%)
@@ -289,11 +335,9 @@
 $(obj2_files): | $(OBJ_DIR)
 
 $(OBJ_DIR)/%.o:%.c
-	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -301,11 +345,9 @@
 endif
 
 $(OBJ_DIR)/%.o:sse/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_SSE) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:sse/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -313,11 +355,9 @@
 endif
 
 $(OBJ_DIR)/%.o:avx/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_AVX) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:avx/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -325,11 +365,9 @@
 endif
 
 $(OBJ_DIR)/%.o:avx2/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_AVX2) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:avx2/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -337,11 +375,9 @@
 endif
 
 $(OBJ_DIR)/%.o:avx512/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_AVX512) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:avx512/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -349,7 +385,16 @@
 endif
 
 $(OBJ_DIR)/%.o:include/%.asm
-	@ echo "Making object file $@ "
+ifeq ($(USE_YASM),y)
+	$(YASM) $(YASM_FLAGS) $< -o $@
+else
+	$(NASM) -o $@ $(NASM_FLAGS) $<
+endif
+
+$(OBJ_DIR)/%.o:no-aesni/%.c
+	$(CC) -c $(CFLAGS_NO_SIMD) $< -o $@
+
+$(OBJ_DIR)/%.o:no-aesni/%.asm
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -370,21 +415,15 @@
 	rm -Rf $(obj2_files)
 	rm -f $(LIB).a $(LIB).so*
 
-SOURCES_DIRS := . sse avx avx2 avx512 include
-SOURCES := $(foreach dir,$(SOURCES_DIRS),$(wildcard $(dir)/*.[ch]) $(wildcard $(dir)/*.asm) $(wildcard $(dir)/*.inc))
-SOURCES_STYLE := $(foreach infile,$(SOURCES),-f $(infile))
-CHECKPATCH?=checkpatch.pl
-# SPACING - produces false positives with tyepdefs and *
-# CONSTANT_COMPARISON - forbids defensive programming technique
-# USE_FUNC - produces false positives for Windows target
-# INITIALISED_STATIC, LEADING_SPACE, SPLIT_STRING, CODE_INDENT,
-# PREFER_ALIGNED, UNSPECIFIED_INT, ARRAY_SIZE, GLOBAL_INITIALISERS,
-# NEW_TYPEDEFS, AVOID_EXTERNS, COMPLEX_MACRO, BLOCK_COMMENT_STYLE
-# - found obsolete in this project
-.PHONY: style
-style:
-	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
---ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
-UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
-NEW_TYPEDEFS,AVOID_EXTERNS,COMPLEX_MACRO,PREFER_ALIGNED,USE_FUNC,\
-CONSTANT_COMPARISON,SPACING $(SOURCES_STYLE)
+CHECKPATCH ?= checkpatch.pl
+# checkpatch ignore settings:
+#   SPACING - produces false positives with tyepdefs and *
+#   CONSTANT_COMPARISON - forbids defensive programming technique
+#   USE_FUNC - produces false positives for Windows target
+#   INITIALISED_STATIC, LEADING_SPACE, SPLIT_STRING, CODE_INDENT,
+#   PREFER_ALIGNED, UNSPECIFIED_INT, ARRAY_SIZE, GLOBAL_INITIALISERS,
+#   NEW_TYPEDEFS, AVOID_EXTERNS, COMPLEX_MACRO, BLOCK_COMMENT_STYLE
+#     - found obsolete in this project
+#
+# NOTE: these flags cannot be broken into multiple lines due to
+#       spaces injected by make

=== debian/changelog ===
intel-ipsec-mb (0.52-2) unstable; urgency=medium

  [ Luca Boccassi ]
  * Fix static library, don't strip (Closes: #918034)
  
 -- Colin Ian King <colin.king@canonical.com>  Wed, 2 Jan 2019 15:13:11 +0000

intel-ipsec-mb (0.52-1) unstable; urgency=medium

  * Sync to latest 0.52 release

 -- Colin Ian King <colin.king@canonical.com>  Thu, 20 Dec 2018 22:01:14 +0000

intel-ipsec-mb (0.51-1) unstable; urgency=medium

  * Sync to latest 0.51 release
  * Remove fix to disable stack execution flag in const.asm as this is now
    in 0.51

 -- Colin Ian King <colin.king@canonical.com>  Wed, 10 Oct 2018 13:01:11 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Standards-Version: 4.1.2
 Homepage: https://github.com/intel/intel-ipsec-mb
 
-Package: libipsec-mb
+Package: libipsec-mb0
 Section: libs
 Architecture: amd64
 Priority: optional
@@ -22,7 +22,7 @@
 Section: libdevel
 Architecture: linux-amd64
 Priority: optional
-Depends: ${misc:Depends}, libipsec-mb
+Depends: ${misc:Depends}, libipsec-mb0 (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
 Description: Development files for Intel(R) Multi-Buffer Crypto for IPSec library
  Libipsec-mb is highly-optimized software implementations of

=== debian/rules ===
--- 
+++ 
@@ -26,8 +26,8 @@
 override_dh_auto_install:
 	# Install the library
 	install -d ${DESTDIR}${LIBDIR}
-	install -m 0644 -s $$(pwd)/libIPSec_MB.a ${DESTDIR}${LIBDIR}
-	install -m 0644 -s $$(pwd)/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}
+	install -m 0644 $$(pwd)/libIPSec_MB.a ${DESTDIR}${LIBDIR}
+	install -m 0644 $$(pwd)/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}
 	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}
 	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so
